import static java.lang.Math.*;
public class functorWorld extends Thread{
    world olWorld;
    int start,
        end;
    atom atomSrc[],
         atomDest[];
    
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    
    public functorWorld(world _olWorld, atom [] atomLst, int _start, int _end)
    {
        olWorld = _olWorld;
        start = _start;
        end = _end;
        atomSrc = atomLst;
        atomDest = new atom[end-start];
        
    }
    
    public void run()
    {
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
        
            nuAtom = new atom(atomSrc[i]);
            //hardcollision with the world
            vector delta = v.sub(olWorld.center, nuAtom.pos);
            double refDistSQ = pow(olWorld.radius- nuAtom.radius,2);
            double diffDistSQ = v.magSQ(delta);
            if (diffDistSQ-refDistSQ > 0)     //higher than 0 if out of border
            {
                nuAtom = a.addforce(nuAtom, a.repulseSQ(nuAtom, olWorld.thing, refDistSQ, diffDistSQ,0.9, 0.1));
            }
            else if (olWorld.gravity > 0)
            {
                //gravity
                //i want 360 gravity
                //it use repulse function, 
                //but swap diffDist and refDist cuz we want proportional to border distance force
                //and negate deepness cuz we want circle border as gravity
                //then , we still want spaceship to go in the middle, then , the power of the gravity is far below world border
                nuAtom = a.addforce(nuAtom, a.repulseSQ(nuAtom, olWorld.thing, diffDistSQ,refDistSQ, 0.4, -0.01));
            }
            
            //velocitydrag
            //drag Force = area * velocity^2 * density * coefficient
            //coefficient = 0.47 for a sphere (supposely dimensionless)
            //density = 1.2 for air , 999 for water
            //area = 2 pi r
            //nuAtom = a.subforce(nuAtom, v.scale(v.normalize(nuAtom.vel), v.magSQ(nuAtom.vel) * nuAtom.radius * 0.0062832));
            //nuAtom = a.subforce(nuAtom, v.scale(nuAtom.vel, v.mag(nuAtom.vel) * nuAtom.radius * 0.0062832));//find optimisation
            //great loss of realism, in order to avoid squareroot, i will try to make it proportional and increase drag force
            nuAtom = a.subforce(nuAtom, v.scale(nuAtom.vel, nuAtom.radius * olWorld.airDrag));  //find better
            //  wind
            // same drag force but use arbitrary direction instead of velocity
            //  etc

            atomDest[i-start] = nuAtom;
        }
    }
}
